/*
 * keyboard input via uart or htif
 */
#include	"u.h"
#include	"../port/lib.h"
#include	"mem.h"
#include	"dat.h"
#include	"fns.h"
#include	"../port/error.h"

static Queue *kbdq;		/* is ignored as first arg to kbdputc */
static int nokbd = 1;		/* flag: no PS/2 keyboard */
static Lock htiflock;

/*
 *  wait for output no longer busy
 */
static int
outready(void)
{
	return 0;
}

/*
 *  wait for input
 */
static int
inready(void)
{
	return 0;
}

static int
outbyte(int, int c)
{
	USED(c);
	return outready();
}

struct {
	int	esc1;
	int	esc2;
	int	alt;
	int	altgr;
	int	caps;
	int	ctl;
	int	num;
	int	shift;
	int	collecting;
	int	nk;
	Rune	kc[1+2*UTFmax+1];	/* worst case: "x12345678\0" */
	int	buttons;
} kbscan;

/*
 * Modern (c. 2017) machines tend to not have 8042 keyboard controllers,
 * but get their console input from USB keyboards or serial ports.
 */
void
kbdinit(void)
{
}

void
kbdenable(void)
{
	if (nokbd)
		return;
	kbdq = qopen(4*1024, 0, 0, 0);
	if(kbdq == nil)
		panic("kbdinit");
	qnoblock(kbdq, 1);
	addkbdq(kbdq, -1);
}
