/*
 * definitions for machine-language startup
 */
#undef DEBUG

#define SPLHI	CSRRC	CSR(SSTATUS), $Sie, R0

/* dedicated registers during start-up */
#define SYSRB	20
#define MACHMODE 21
#define RKSEG0	22
#define TMP2	23
#define LOCK	24
#define UART0	25
#define PRTMP	26
#define CSRZERO	27
#define TMP	29
#define MACHNO	30
#define HARTID	31

#define INITSTKSIZE	PGSZ

#define ALIGNPAT 0x12345678

/* spinlock from unpriv. isa spec., figure a.7 */
#define ACQLOCK	\
	MOV	$1, R(TMP2); \
	FENCE; \
	/* after: old printlck in R(TMP), updated printlck in memory */ \
	AMOW(Amoswap, AQ|RL, TMP2, LOCK, TMP); \
	BNE	R(TMP), -3(PC);		/* was non-0? lock held by another */ \
	FENCE
#define RELLOCK \
	FENCE; \
	MOVW	R0, (R(LOCK)); \
	FENCE

#ifdef DEBUG
/* 0x20 in Lsr (uart reg 5) is Thre (Thr empty). assumes R(UART0) is set. */
#define CONSPUT(c) \
	FENCE; \
	MOVWU	(5*4)(R(UART0)), R(TMP); \
	AND	$0x20, R(TMP); \
	BEQ	R(TMP), -3(PC); \
	MOV	c, R(TMP); \
	MOVW	R(TMP), (R(UART0))
#define CONSPUTLCK(c) \
	ACQLOCK; \
	CONSPUT(c); \
	RELLOCK
#define PRIDMACHNO(id) \
	ACQLOCK; \
	CONSPUT(id); \
	ADD	$'0', R(MACHNO), R(PRTMP); \
	CONSPUT(R(PRTMP)); \
	RELLOCK
#else
#define CONSPUT(c)
#define CONSPUTLCK(c)
#define PRIDMACHNO(id)
#endif

#define LOADSATP(reg); \
	FENCE; \
	FENCE_I; \
	SFENCE_VMA(0, 0)			/* flush TLB */; \
	MOV	reg, CSR(SATP); \
	SFENCE_VMA(0, 0)			/* flush TLB */; \
	FENCE; \
	FENCE_I
